from tkinter import *
import time


"""
A program that executes an algorithm to measure out 4 litres from containers of 7l and 5l.
The 4l must be contained in the smaller container at the end of the process, and the larger one empty.
You can : fill either container from a tap; empty one container into another until one is full or the other empty; empty a container into a sink.
The algorithm is:
1. Fill the larger container.
2. Pour the large one into the small one, until the smaller container is full.
3. Empty the small one into a sink
4. Pour the difference from the larger into the smaller

Repeat steps 1-4.

The larger container will be empty and the smaller one will contain 4l.

"""


def Create_Container(number, volume) :
    currentV = 0
    newc = {"number":number, "maxVolume":volume, "currentVolume":currentV }
    return newc


def Fill_Container(thisC) :
    thisC["currentVolume"] = thisC["maxVolume"]

def Empty_Container(thisC) :
    thisC["currentVolume"] = 0


def Pour_LargetoSmall(lC, sC) :
    sC["currentVolume"] = sC["currentVolume"] +lC["currentVolume"]  #pour the large entirely into small: if the small volume is below max then no more to do on small C
    lC["currentVolume"] = 0                                         #empty the large C
    if sC["currentVolume"] > sC["maxVolume"] :                      #if current volume of small C exceeds the max volume of the small then remove the surplus
        overCapacity = sC["currentVolume"] - sC["maxVolume"]
        lC["currentVolume"] = overCapacity                          #pour the surplus back into the large C
        sC["currentVolume"] = sC["maxVolume"]                       #make sure the small C doesnt contain more than the max

def Step1() :
    Fill_Container(largeC)                  # Step 1
    stepText = "1. Fill the larger container"
    drawContainer(stepText)
    print("fill large:" , largeC.items(), " small: ", smallC.items())

def Step2() :
    Pour_LargetoSmall(largeC, smallC)       # Step 2
    stepText = "2. Pour the large one into the small one"
    drawContainer(stepText)
    print("pour large:" , largeC.items(), " small: ", smallC.items())

def Step3() :
    Empty_Container(smallC)                 # Step 3
    stepText = "3. Empty the small one into a sink"
    drawContainer(stepText)
    print("empty large:" , largeC.items(), " small: ", smallC.items())

def Step4() :
    Pour_LargetoSmall(largeC, smallC)       # Step 4
    stepText = "4. Pour from the larger into the smaller"
    drawContainer(stepText)
    print("pour large:" , largeC.items(), " small: ", smallC.items())

	
def REInitialiseContainers() :
    #Re-Initialise the large and small container
    largeC["currentVolume"] = 0
    smallC["currentVolume"] = 0 
    print("pour large:" , largeC.items(), " small: ", smallC.items())
    drawContainer("Re Initialised")
    
def drawContainer(stepText) :

    Label(win, width=30, height=2, text=stepText, fg="red").grid(row=1, column=6, sticky=W)
    rowStart = 8 
    for i in range(3,rowStart) :
        Label(win, bg = winbg).grid(row=i, column=0, sticky=W)
        
    print("pour large:" , largeC.items(), " small: ", smallC.items())
    #Container Visuals ------------------------------------------------------------------------------------------
    #show the large Container as made up of empty 1 litre sections 
    for i in range(rowStart, rowStart + largeC["maxVolume"]):
        Label(win,width=10, height=1,bg=winbg).grid(row=i, column=0, sticky=W)
        Label(win,width=10, height=1,bg="light blue", bd=1).grid(row=i, column=1, sticky=W)
    
    #show the small Container as made up of empty 1 litre sections        
    for i in range(rowStart + 2, rowStart + 2 + smallC["maxVolume"]):
        Label(win,width=10, height = 1, bg=winbg).grid(row=i, column=2, sticky=W)
        Label(win,width=10, height = 1, bg="light blue", bd=1).grid(row=i, column=3, sticky=W)
        Label(win,width=10, height = 1, bg=winbg).grid(row=i, column=4, sticky=W)

        
    #fill the large Container with the current volume       
    baseLC = rowStart + largeC["maxVolume"] - 1
    for i in range(baseLC, baseLC - largeC["currentVolume"], -1):
        Label(win,width=10, height=1,bg="red", text = str(baseLC - i + 1), bd=1).grid(row=i, column=1, sticky=W)



    #fill the small Container with the current volume
    baseSC = rowStart + 2 + smallC["maxVolume"] - 1
    for i in range(baseSC, baseSC - smallC["currentVolume"], -1) :
        Label(win,width=10, bg="red", text = str(baseSC - i +1), bd=1).grid(row=i, column=3, sticky=W)


    #insert some space below the containers
    Label(win, width=10, height=2, text="LARGE C").grid(row=16, column=1)
    Label(win, width=10, height=2, text="SMALL C").grid(row=16, column=3)
    
    for i in range(17,20) :
        Label(win, bg=winbg).grid(row=i, column=0, sticky=W)
    #------------------------------------------------------------------------------------------------------------------


#Execute the 4 steps of the algorithm
#global largeC, smallC
largeC = Create_Container(1, 7)
smallC = Create_Container(2, 5)

# initialise the Tkinter window
win = Tk()
win.title("UI - Die Hard Container Graphic")
#win.maxsize(width=150, height=150)
win.minsize(width=100, height=100)
winbg = "blue"
win.configure(bg=winbg)

drawContainer("Let\'s Start")
"""
photo = PhotoImage(file="icon.gif")
w = Label(win, image=photo)
w.photo = photo
w.pack()
"""

#The 2 Buttons SUBMIT and QUIT give the user control over the Graphical UI
button  = Button(win, text="RESET", command=REInitialiseContainers).grid(row=20,column=0, sticky=W)
button1 = Button(win, text="STEP1", command=Step1).grid(row=20,column=1, sticky=W)
button2 = Button(win, text="STEP2", command=Step2).grid(row=20,column=2, sticky=W)
button3 = Button(win, text="STEP3", command=Step3).grid(row=20,column=3, sticky=W)
button4 = Button(win, text="STEP4", command=Step4).grid(row=20,column=4, sticky=W)

qbutton = Button(win, text="QUIT", command=win.destroy).grid(row=20, column=6, sticky=W)


win.mainloop()      # infinite loop to capture events
